--
-- PostgreSQL database dump
--

-- Dumped from database version 12.3
-- Dumped by pg_dump version 12.3

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;

SET default_table_access_method = heap;

CREATE TABLE public.akas (
    tconst_id integer NOT NULL,
    ordering smallint NOT NULL,
    title character varying(500),
    is_original_title smallint,
    region_id smallint,
    language_id smallint,
    akas_type_id smallint,
    attributes character varying(250)
);


CREATE TABLE public.akas_types (
    akas_type_id smallint NOT NULL,
    akas_type character varying(25) NOT NULL
);


CREATE TABLE public.categories (
    category_id smallint NOT NULL,
    category character varying NOT NULL
);


CREATE TABLE public.crew_directors (
    tconst_id integer NOT NULL,
    nconst_id integer NOT NULL
);


CREATE TABLE public.crew_writers (
    tconst_id integer NOT NULL,
    nconst_id integer NOT NULL
);


CREATE TABLE public.episodes (
    tconst_id integer NOT NULL,
    parent_tconst_id integer NOT NULL,
    season_number smallint,
    episode_number smallint
);


CREATE TABLE public.genres (
    genre_id smallint NOT NULL,
    genre character varying(25) NOT NULL
);


CREATE TABLE public.languages (
    language_id smallint NOT NULL,
    language character varying(5) NOT NULL
);


CREATE TABLE public.names (
    nconst_id integer NOT NULL,
    nconst character varying(10) NOT NULL,
    primary_name character varying(75) NOT NULL,
    birth_year smallint,
    death_year smallint
);


CREATE TABLE public.names_known_for_titles (
    nconst_id integer NOT NULL,
    tconst_id integer NOT NULL
);


CREATE TABLE public.names_professions (
    nconst_id integer NOT NULL,
    profession_id smallint NOT NULL
);


CREATE TABLE public.principals (
    tconst_id integer NOT NULL,
    nconst_id integer NOT NULL,
    ordering smallint NOT NULL,
    category_id smallint NOT NULL
);


CREATE TABLE public.principals_characters (
    tconst_id integer NOT NULL,
    nconst_id integer NOT NULL,
    "character" character varying(500) NOT NULL
);


CREATE TABLE public.principals_jobs (
    tconst_id integer NOT NULL,
    nconst_id integer NOT NULL,
    job character varying(500) NOT NULL
);


CREATE TABLE public.professions (
    profession_id smallint NOT NULL,
    profession character varying(30) NOT NULL
);


CREATE TABLE public.ratings (
    tconst_id integer NOT NULL,
    average_rating numeric(3,1) NOT NULL,
    num_votes integer NOT NULL
);


CREATE TABLE public.regions (
    region_id smallint NOT NULL,
    region character varying(5) NOT NULL
);


CREATE TABLE public.title_types (
    title_type_id smallint NOT NULL,
    title_type character varying(25) NOT NULL
);


CREATE TABLE public.titles (
    tconst_id integer NOT NULL,
    tconst character varying(10) NOT NULL,
    primary_title character varying(400),
    original_title character varying(400),
    title_type_id smallint NOT NULL,
    is_adult smallint NOT NULL,
    start_year smallint,
    end_year smallint,
    runtime_minutes integer
);


CREATE TABLE public.titles_genres (
    tconst_id integer NOT NULL,
    genre_id smallint NOT NULL
);


ALTER TABLE ONLY public.akas
    ADD CONSTRAINT akas_pkey PRIMARY KEY (tconst_id, ordering);


ALTER TABLE ONLY public.akas_types
    ADD CONSTRAINT akas_types_pkey PRIMARY KEY (akas_type_id);


ALTER TABLE ONLY public.categories
    ADD CONSTRAINT categories_pkey PRIMARY KEY (category_id);


ALTER TABLE ONLY public.crew_directors
    ADD CONSTRAINT crew_directors_pkey PRIMARY KEY (tconst_id, nconst_id);


ALTER TABLE ONLY public.crew_writers
    ADD CONSTRAINT crew_writers_pkey PRIMARY KEY (tconst_id, nconst_id);


ALTER TABLE ONLY public.episodes
    ADD CONSTRAINT episodes_pkey PRIMARY KEY (tconst_id);


ALTER TABLE ONLY public.genres
    ADD CONSTRAINT genres_pkey PRIMARY KEY (genre_id);


ALTER TABLE ONLY public.languages
    ADD CONSTRAINT languages_pkey PRIMARY KEY (language_id);


ALTER TABLE ONLY public.names_known_for_titles
    ADD CONSTRAINT names_known_for_titles_pkey PRIMARY KEY (nconst_id, tconst_id);


ALTER TABLE ONLY public.names
    ADD CONSTRAINT names_nconst_unique UNIQUE (nconst);


ALTER TABLE ONLY public.names
    ADD CONSTRAINT names_pkey PRIMARY KEY (nconst_id);


ALTER TABLE ONLY public.names_professions
    ADD CONSTRAINT names_professions_pkey PRIMARY KEY (nconst_id, profession_id);


ALTER TABLE ONLY public.principals_characters
    ADD CONSTRAINT principals_characters_pkey PRIMARY KEY (tconst_id, nconst_id, "character");


ALTER TABLE ONLY public.principals_jobs
    ADD CONSTRAINT principals_jobs_pkey PRIMARY KEY (tconst_id, nconst_id, job);


ALTER TABLE ONLY public.principals
    ADD CONSTRAINT principals_pkey PRIMARY KEY (tconst_id, nconst_id);


ALTER TABLE ONLY public.professions
    ADD CONSTRAINT professions_pkey PRIMARY KEY (profession_id);


ALTER TABLE ONLY public.ratings
    ADD CONSTRAINT ratings_pkey PRIMARY KEY (tconst_id);


ALTER TABLE ONLY public.regions
    ADD CONSTRAINT regions_pkey PRIMARY KEY (region_id);


ALTER TABLE ONLY public.title_types
    ADD CONSTRAINT title_types_pkey PRIMARY KEY (title_type_id);


ALTER TABLE ONLY public.titles_genres
    ADD CONSTRAINT titles_genres_pkey PRIMARY KEY (tconst_id, genre_id);


ALTER TABLE ONLY public.titles
    ADD CONSTRAINT titles_pkey PRIMARY KEY (tconst_id);


ALTER TABLE ONLY public.titles
    ADD CONSTRAINT titles_tconst_unique UNIQUE (tconst);


ALTER TABLE ONLY public.akas
    ADD CONSTRAINT akas_akas_types_fkey FOREIGN KEY (akas_type_id) REFERENCES public.akas_types(akas_type_id);


ALTER TABLE ONLY public.akas
    ADD CONSTRAINT akas_languages_fkey FOREIGN KEY (language_id) REFERENCES public.languages(language_id);


ALTER TABLE ONLY public.akas
    ADD CONSTRAINT akas_regions_fkey FOREIGN KEY (region_id) REFERENCES public.regions(region_id);


ALTER TABLE ONLY public.akas
    ADD CONSTRAINT akas_titles_fkey FOREIGN KEY (tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.crew_directors
    ADD CONSTRAINT crew_directors_names_fkey FOREIGN KEY (nconst_id) REFERENCES public.names(nconst_id);


ALTER TABLE ONLY public.crew_directors
    ADD CONSTRAINT crew_directors_titles_fkey FOREIGN KEY (tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.crew_writers
    ADD CONSTRAINT crew_writers_names_fkey FOREIGN KEY (nconst_id) REFERENCES public.names(nconst_id);


ALTER TABLE ONLY public.crew_writers
    ADD CONSTRAINT crew_writers_titles_fkey FOREIGN KEY (tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.episodes
    ADD CONSTRAINT episodes_parents_fkey FOREIGN KEY (parent_tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.episodes
    ADD CONSTRAINT episodes_titles_fkey FOREIGN KEY (tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.names_known_for_titles
    ADD CONSTRAINT names_known_for_titles_names_fkey FOREIGN KEY (nconst_id) REFERENCES public.names(nconst_id);


ALTER TABLE ONLY public.names_known_for_titles
    ADD CONSTRAINT names_known_for_titles_titles_fkey FOREIGN KEY (tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.names_professions
    ADD CONSTRAINT names_professions_names_fkey FOREIGN KEY (nconst_id) REFERENCES public.names(nconst_id);


ALTER TABLE ONLY public.names_professions
    ADD CONSTRAINT names_professions_professions_fkey FOREIGN KEY (profession_id) REFERENCES public.professions(profession_id);


ALTER TABLE ONLY public.principals
    ADD CONSTRAINT principals_categories_fkey FOREIGN KEY (category_id) REFERENCES public.categories(category_id);


ALTER TABLE ONLY public.principals_characters
    ADD CONSTRAINT principals_characters_principals_fkey FOREIGN KEY (tconst_id, nconst_id) REFERENCES public.principals(tconst_id, nconst_id);


ALTER TABLE ONLY public.principals_jobs
    ADD CONSTRAINT principals_jobs_principals_fkey FOREIGN KEY (nconst_id, tconst_id) REFERENCES public.principals(nconst_id, tconst_id);


ALTER TABLE ONLY public.principals
    ADD CONSTRAINT principals_names_fkey FOREIGN KEY (nconst_id) REFERENCES public.names(nconst_id);


ALTER TABLE ONLY public.principals
    ADD CONSTRAINT principals_titles_fkey FOREIGN KEY (tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.ratings
    ADD CONSTRAINT ratings_titles_fkey FOREIGN KEY (tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.titles_genres
    ADD CONSTRAINT titles_genres_genres_fkey FOREIGN KEY (genre_id) REFERENCES public.genres(genre_id);


ALTER TABLE ONLY public.titles_genres
    ADD CONSTRAINT titles_genres_titles_fkey FOREIGN KEY (tconst_id) REFERENCES public.titles(tconst_id);


ALTER TABLE ONLY public.titles
    ADD CONSTRAINT titles_titles_types_fkey FOREIGN KEY (title_type_id) REFERENCES public.title_types(title_type_id);
